using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EvoBoat.EvoAlg
{
    /// <summary>
    /// specification of a general problem 
    /// </summary>
    /// <typeparam name="R">output type</typeparam>
    public interface IProblem<S, R>
        where S : ISolution<R>
    {
        int Dimension { get; }
        double Evaluate(R vector);
        double Evaluate(S solution);
        bool IsFeasible(R vector);
    }
}
